<template>
  <div class="murr-tavern__chat">
  <div class="chat">
    <div class="chat-content" :class="{ 'no-auth': !isAuthenticated }">
      <p class="chat-online" v-if="isAuthenticated">
        Онлайн в таверне - <span>{{ murrensOnline }}</span>
      </p>
      <observer
        @murrIntersect="socketInit"
        :key="'authObserver'"
        v-if="isAuthenticated && !socketInitialized"
      />
      <ul v-if="isAuthenticated" class="chat-received" ref="receiveBlock">
        <observer
          @murrIntersect="fetchPreviousMessages"
          :key="'messagesObserver' + messages.length"
          v-if="messages.length"
        />
        <loader v-if="isLoading" />
        <murr-chat-message
          @addMurrenNameToAnswer="addMurrenNameToAnswer"
          v-for="m in messages"
          :key="m.id"
          :message="m"
        />
      </ul>
      <el-button
        class="murr-button__success"
        v-else
        @click.prevent="$store.commit('changeShowLoginForm_mutations')"
      >
        Для использования чата - войди
      </el-button>
    </div>
    <div class="chat-new_message" v-if="isAuthenticated">
      <resizable-textarea>
        <textarea
          class="chat-new_message__textarea"
          placeholder="Напиши сообщение..."
          v-model="text"
          maxlength="224"
          rows="1"
          ref="textareaMessage"
          @keydown.enter="
            ($event) => {
              if (!$event.shiftKey) sendChatMessage($event);
            }
          "
        ></textarea>
      </resizable-textarea>
      <el-button
        class="chat-new_message__button"
        icon="el-icon-s-promotion"
        @click="sendChatMessage"
      ></el-button>
    </div>
  </div>
    </div>
</template>

<script>
import ResizableTextarea from "../common/ResizableTextarea.js";
import MurrChatMessage from "./MurrChatMessage.vue";
import sanitizeHtml from "sanitize-html";
import Observer from "../common/Observer.vue";
import * as type from "./store/type.js";
import { websocket_base_url, tavernSocketUrl } from "../../devAndProdVariables";

import "./scss/style.scss";

export default {
  name: "murr-chat",
  data() {
    return {
      text: "",
      lastMessage: true,
      isLoading: true,
      socketInitialized: false,
    };
  },
  created() {
    this.$nextTick(() => {
      if (this.isAuthenticated) this.socketInit();
    });
  },
  beforeDestroy() {
    this.$store.commit(type.CHAT_CLEAR);
    this.socketClose();
  },
  computed: {
    messages() {
      return this.$store.getters.chatMessages;
    },
    murrensOnline() {
      return this.$store.getters.murrensOnline.length;
    },
    isAuthenticated() {
      return !!this.$store.getters.currentMurren;
    },
  },
  methods: {
    addMurrenNameToAnswer(murrenName) {
      this.text = `@${murrenName}, ${this.text}`;
      this.$refs.textareaMessage.focus();
    },
    socketListener(event) {
      let socketMessage = JSON.parse(event.data);
      let actionType = null;
      let data = socketMessage.data;
      let gan = socketMessage.gan;
      let oldScrollHeight = null;
      let receiveBlock = this.$refs.receiveBlock;
      let scrolling = false;

      if (gan === "list_messages") {
        if (data.offset === 0) {
          actionType = type.CHAT_MESSAGES_SET;
        } else {
          actionType = type.CHAT_MESSAGES_PREPEND;
          oldScrollHeight = receiveBlock.scrollHeight;
        }
        this.lastMessage = data.last_message;
        data = data.messages;
        scrolling = true;
      } else if (gan === "disconnect") {
        actionType = type.CHAT_MURREN_REMOVE_ONLINE;
      } else if (gan === "send_chat_message") {
        actionType = type.CHAT_MESSAGE_APPEND;
        if (data.murren_name === this.$store.getters.currentMurren.username)
          scrolling = true;
        else
          scrolling =
            receiveBlock.scrollTop + 100 >=
            receiveBlock.scrollHeight - receiveBlock.clientHeight;
        data.message = data.message.replace(
          "@" + this.$store.getters.currentMurren.username,
          `<span class="highlight-name">${
            "@" + this.$store.getters.currentMurren.username
          }</span>`
        );
      } else if (gan === "join_to_murr_chat") {
        let newMurrens = [];
        data.murrens_in_ws_data.map((murren) => {
          let murrenAlreadyOnline = this.$store.getters.murrensOnline.find(
            (m) => m.name === murren.murren_name
          );
          if (!murrenAlreadyOnline)
            newMurrens.push({
              name: murren.murren_name,
              color: this.randColor(),
            });
        });
        data = newMurrens;
        actionType = type.CHAT_MURRENS_APPEND_ONLINE;
      } else {
        // eslint-disable-next-line no-console
        console.log(`Неизвестное действие(gan - "${gan}")`);
      }

      if (actionType) this.$store.commit(actionType, data);

      if (scrolling)
        this.$nextTick(() => {
          receiveBlock.scrollTop = oldScrollHeight
            ? receiveBlock.scrollHeight - oldScrollHeight
            : receiveBlock.scrollHeight;
          this.isLoading = false;
        });
    },

    socketError(error) {
      // eslint-disable-next-line no-console
      console.log("Ошибка " + error.message);
    },

    socketOpened() {
      this.fetchMessages();
    },

    socketClosed(event) {
      if (event.wasClean) {
        // eslint-disable-next-line no-console
        console.log("Соединение закрыто чисто");
      } else {
        // eslint-disable-next-line no-console
        console.log("Обрыв соединения");
      }
      // eslint-disable-next-line no-console
      console.log("Код: " + event.code + " причина: " + event.reason);
    },

    socketInit() {
      let token = this.$store.getters.currentMurren.token;
      let endpoint = websocket_base_url + tavernSocketUrl + "?token=";
      this.socket = new WebSocket(endpoint + token);

      this.socket.onopen = this.socketOpened;
      this.socket.onclose = this.socketClosed;
      this.socket.onmessage = this.socketListener;
      this.socket.onerror = this.socketError;

      this.socketInitialized = true;
    },

    socketClose() {
      this.socket.onclose = {};
      this.socket.close();
      // eslint-disable-next-line no-console
      console.log("socket closed");
    },

    fetchPreviousMessages() {
      if (this.lastMessage) return;

      this.isLoading = true;
      this.fetchMessages(this.messages.length);
    },

    fetchMessages(offset) {
      let data = {
        offset: offset ? offset : 0,
      };
      this.socket.send(
        JSON.stringify({
          data: data,
          gan: "list_messages",
        })
      );
    },

    async sendChatMessage(e) {
      e.preventDefault();

      let text = await sanitizeHtml(this.text, { allowedTags: [] });
      text = text.trim();

      if (text.length !== 0) {
        e.stopPropagation();

        let message = await this.__prepareMessage(text);
        await this.socket.send(
          JSON.stringify({
            data: { message: message },
            gan: "send_chat_message",
          })
        );
      }
      this.text = "";
      this.$refs.textareaMessage.style = "";
    },

    async __prepareMessage(message) {
      let messageLines = message.split("\n");

      messageLines = messageLines.map((line) => {
        line = line.length !== 0 ? line : "<br/>";
        return `<p>${line}</p>`;
      });

      message = await sanitizeHtml(messageLines.join(""), {
        allowedTags: ["p", "br"],
      });
      return message;
    },

    randColor() {
      let letters = "0123456789ABCDEF";
      let color = "#";
      for (let i = 0; i < 6; i++) {
        color += letters[Math.floor(Math.random() * 16)];
      }
      return color;
    },
  },

  components: {
    ResizableTextarea,
    MurrChatMessage,
    Observer,
  },
};
</script>
